package com.example.autorization.ui.fragments

import android.os.Bundle
import android.view.MenuItem
import android.view.View
import android.widget.PopupMenu
import android.widget.PopupMenu.OnMenuItemClickListener
import androidx.fragment.app.Fragment
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.example.autorization.R
import com.example.autorization.ui.adapters.UserAdapter
import com.example.autorization.ui.fragments.signup.User


class UsersFragment : Fragment(R.layout.fragment_users) {

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        val recyclerView = view.findViewById<RecyclerView>(R.id.UserRecyclerView)
        val users: List<User> = mutableListOf(
            User(email = "test@mail.ru", name = "Alex", password = "123"),
            User(email = "test@mail.ru", name = "Bob", password = "321"),
            User(email = "test@mail.ru", name = "Alex", password = "123"),
            User(email = "test@mail.ru", name = "Bob", password = "321"),
            User(email = "test@mail.ru", name = "Alex", password = "123"),
            User(email = "test@mail.ru", name = "Alex", password = "123"),
            User(email = "test@mail.ru", name = "Bob", password = "321"),
            User(email = "test@mail.ru", name = "Alex", password = "123"),
        )
        recyclerView.layoutManager = LinearLayoutManager(requireContext())
        val userAdapter = UserAdapter(users)
        recyclerView.adapter = userAdapter
        userAdapter.OnClick = { index, view ->
            showMenu(view, userAdapter, index)
        }

    }


    private fun showMenu(
        view:View,
         userAdapter: UserAdapter,
         index:Int){
       PopupMenu(requireContext(), view).apply {
           setOnMenuItemClickListener { item ->
               when (item?.itemId) {
                   R.id.DeleteAction -> {
                       userAdapter.deleteUserById(index)
                       true
                   }
                   else -> true
               }
           }
           inflate(R.menu.user_action_menu)
           show()
       }


    }
}